%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%     	        
%                                                         %
% Mthodes de descente pour l''optimisation non linaire  %              
% sans contraintes                                        %              
% 					                  % 
% Frank-Crittin Michael Themans				  % 
% IMA-ROSO Mars 2003		                          % 
%  					                  % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
 
clear; % ncessaire pour l''interface graphique
 
%%%%%%%%%%%%%%%% 
%% Interface    %	         		
%%%%%%%%%%%%%%%%
 
% nom de la fonction  minimiser, qui est spcifie dans le fichier 'f1.m'  
% et qui est dclare sous forme de string

fct = 'f1' ; 
 
% point initial 

x = [-1.5; -2] ; 
 
%%%%%%%%%%%%%%%%%%
%% Parametres     %		   
%%%%%%%%%%%%%%%%%%
 
% pour le critre d''arrt 

epsilon = 0.001 ; 
maxiter = 200   ;  
 
% taille de pas initial 

alpha = 1 ; 
 
% initialisation du nombre d''iterations 

i=1 ;  
 
% initialisation de la matrice qui stocke tous les itrs 
% un itr=une colonne de cette matrice

stock(:,1) = x; 

 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%% Boucle principale 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
 

% Critere d''arret: ( normGradient(fct,x) < epsilon ) OR ( i > maxiter )

while ( normGradient(fct,x) >= epsilon ) & ( i < maxiter )
  
% calcul de la direction et de la taille du pas
% changez la mthode de calcul par vos propres fonctions
d      = direction(fct,x); 
alpha  = taillepas(fct,x,1,d); 
    
% calcul du nouvel itr 

x = x + alpha * d;
 
% mise  jour du nombre d''iterations

i = i+1;   
 
% stockage de la valeur des diffrents itrs   

stock(:,i)= x ; 
 
end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%% Affichage des rsultats  %				   
%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

% calcul la taille de la matrice contenant tous les itrs	  
    
taille = length(stock); 
     
% valuation de la fonction en chaque point 
     
for i=1:taille 
valeurstock(i)=feval(fct,stock(:,i)); 
end 
     
disp('Valeur de la suite des itrs :') ; 
stock' 

disp('*****************************************')
disp(['Nombre d''itrations :                   ' num2str(i-1)])
disp(['Valeur de la fonction  l''optimum : ' num2str(feval(fct,x))] ) ; 
disp('Valeur de l''optimum : ')  
xOptim = x' 
disp('*****************************************')
         
% passage au module de visualisation de la fonction et des rsultats 
    
visual3d(fct, stock, valeurstock); 
     
clear; 
 
% sprintf('Nombre de fois que la boucle a t parcourue : %d',i)                    



